<?php

function _moduleinfo_collector_process_helper_usage(&$context, &$data, &$qp) {
  $regex = '#/project/usage/(.+)$#';
  $qp_options = array('strip_low_ascii' => TRUE, 'convert_to_encoding' => 'UTF-8', 'convert_from_encoding' => 'UTF-8', 'replace_entities' => TRUE);

  $batch_cnt = 0;
  $modules = array();
  foreach ($qp as $elem) {
    $batch_cnt++;

    // Batch Limit breaker
    if ($context['sandbox']['progress'] >= $context['sandbox']['next_limit']) {
      break;
    }

    // Batch Startpoint reacher
    if ($batch_cnt < $context['sandbox']['progress']) {
      continue;
    }

    $module = new stdClass();

    $tds = htmlqp($elem, NULL, $qp_options)->children('td')->get();

    $module->position = $batch_cnt;
    $module->rank = intval(preg_replace('/[^0-9]/', '', htmlqp($tds[0], NULL, $qp_options)->text()));
    $module->usage = intval(preg_replace('/[^0-9]/', '', htmlqp($tds[2], NULL, $qp_options)->text()));

    $module->href = trim(htmlqp($tds[1], NULL, $qp_options)->find('a')->attr('href'));

    if (!preg_match($regex, $module->href, $hits)) {
      continue;
    }

    $module->name = trim($hits[1]);
    $module->human_name = $module->name;
    $modules[$module->name] = $module;

    moduleinfo_collector_api_modules_insertreplace(array(
      'name' => $module->name,
      'human_name' => $module->human_name,
      'rank' => $module->rank,
      'usages' => $module->usage,
      'position' => $module->position,
      'href_usage' => 'http://drupal.org' . $module->href,
      'href_project' => 'http://drupal.org/project/' . $module->name,
      'processed' => MODULEINFO_COLLECTOR_PROCESS_USAGE,
      'status' => 1,
    ));

    // Store some result for post-processing in the finished callback.
    $context['results'][] = check_plain($module->name);

    // Update our progress information.
    $context['sandbox']['progress']++;
    $context['sandbox']['current_node'] = $module->name;
    $context['message'] = t('Last processed module: %module // Processed: %processed of %max', array(
      '%module' => $module->human_name,
      '%processed' => $context['sandbox']['progress'],
      '%max' => $context['sandbox']['max'])
    );
  }

  // TODO: Make limit configurable
  $context['sandbox']['next_limit'] += 200;
}