<?php

/**
 * @file
 * Plugin who deals with template files.
 */

$plugin = array(
  'name' => 'Template Files',
  'description' => 'Scans Drupal for template files.',
  'scan callbacks' => array(
    '_moduleinfo_template_files_scan' => array(
      'scan' => array(
        '/.+\.tpl\.php$/i',
      ),
      'skip' => array(),
    ),
  ),
  'render callbacks' => array(
    '_moduleinfo_template_files_defined' => t('Available Template Files'),
  ),
);

/**
 * Scans templates for useful informations.
 *
 * @param string $module_name
 *   Name of the current module
 * @param string $content
 *   Content of the current processed file
 * @param string $uri
 *   URI of the file.
 * @return array
 *
 * @TODO: Implement that feature!
 */
function _moduleinfo_template_files_scan($module_name, $content, $uri) {
  return array();
}

/**
 * Renders informations about template files.
 *
 * @param string $module_name
 *   Name of the module to display.
 *
 * @return string
 *   Rendered informations.
 *
 * @TODO: Implement that feature!
 */
function _moduleinfo_template_files_defined_collector($module_name = NULL) {
  return array();
}

/**
 * Renders informations about template files.
 *
 * @param string $module_name
 *   Name of the module to display.
 *
 * @return string
 *   Rendered informations.
 *
 * @TODO: Implement that feature!
 */
function _moduleinfo_template_files_defined_renderer($module_name = NULL, $items = array()) {
  return '';

  if (!isset($cache['template files'])) {
    return '';
  }

  $items = array();
  foreach ($cache['template files'] as $template => $def) {
    $items[] = array(
      'info' => '<span class="mono">' . $def['file'] . '</span>',
      'desc' => $def['shortinfo'],
    );
  }

  return _moduleinfo_helper_fieldset($items, array(
    '#title' => t('Template Files'),
    '#description' => t('Lists all the found template files. These have .tpl.php at the end.'),
  ));
}
